package com.sunyard.chsm.param;

import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

@Data
public class AsymVerifyRawReq {

    // 密钥ID
    @NotNull(message = "密钥ID不能为空")
    private Long keyId;

    // 密钥索引
    @NotEmpty(message = "密钥索引不能为空")
    @Size(min = 15, max = 24, message = "密钥索引长度在15-24")
    private String keyIndex;

    // 签名值,使用Base64编码
    @NotBlank(message = "密文不能为空")
    private String signData;

    // 原文,使用Base64编码
    @NotBlank(message = "明文不能为空")
    private String plainData;

    // 是否进行预处理 默认是
    private boolean preProcess = true;

    // 预处理的userId,使用Base64编码
    private String userId;
}
